Configure: stop forcing use of DEFINE macros in headers
[openssl.git] / tools / c_rehash.in
index 887e927..ad72b51 100644 (file)
@@ -1,11 +1,20 @@
-#!/usr/local/bin/perl
+#!{- $config{HASHBANGPERL} -}
+
+# {- join("\n# ", @autowarntext) -}
+# Copyright 1999-2018 The OpenSSL Project Authors. All Rights Reserved.
+#
+# Licensed under the Apache License 2.0 (the "License").  You may not use
+# this file except in compliance with the License.  You can obtain a copy
+# in the file LICENSE in the source distribution or at
+# https://www.openssl.org/source/license.html
 
 # Perl c_rehash script, scan all files in a directory
 # and add symbolic links to their hash values.
 
-my $dir;
-my $prefix;
+my $dir = {- quotify1($config{openssldir}) -};
+my $prefix = {- quotify1($config{prefix}) -};
 
+my $errorcount = 0;
 my $openssl = $ENV{OPENSSL} || "openssl";
 my $pwd;
 my $x509hash = "-subject_hash";
@@ -15,13 +24,13 @@ my $symlink_exists=eval {symlink("",""); 1};
 my $removelinks = 1;
 
 ##  Parse flags.
-while ( $ARGV[0] =~ '-.*' ) {
+while ( $ARGV[0] =~ /^-/ ) {
     my $flag = shift @ARGV;
     last if ( $flag eq '--');
-    if ( $flag =~ /-old/) {
+    if ( $flag eq '-old') {
            $x509hash = "-subject_hash_old";
            $crlhash = "-hash_old";
-    } elsif ( $flag =~ /-h/) {
+    } elsif ( $flag eq '-h' || $flag eq '-help' ) {
            help();
     } elsif ( $flag eq '-n' ) {
            $removelinks = 0;
@@ -29,15 +38,15 @@ while ( $ARGV[0] =~ '-.*' ) {
            $verbose++;
     }
     else {
-           print STDERR "Usage error; try -help.\n";
+           print STDERR "Usage error; try -h.\n";
            exit 1;
     }
 }
 
 sub help {
-       print "Usage: c_rehash [-old] [-h] [-v] [dirs...]\n";
+       print "Usage: c_rehash [-old] [-h] [-help] [-v] [dirs...]\n";
        print "   -old use old-style digest\n";
-       print "   -h print this help text\n";
+       print "   -h or -help print this help text\n";
        print "   -v print files removed and linked\n";
        exit 0;
 }
@@ -54,24 +63,24 @@ if (defined(&Cwd::getcwd)) {
 my $path_delim = ($pwd =~ /^[a-z]\:/i) ? ';' : ':';
 $ENV{PATH} = "$prefix/bin" . ($ENV{PATH} ? $path_delim . $ENV{PATH} : "");
 
-if(! -x $openssl) {
+if (! -x $openssl) {
        my $found = 0;
        foreach (split /$path_delim/, $ENV{PATH}) {
-               if(-x "$_/$openssl") {
+               if (-x "$_/$openssl") {
                        $found = 1;
                        $openssl = "$_/$openssl";
                        last;
                }       
        }
-       if($found == 0) {
+       if ($found == 0) {
                print STDERR "c_rehash: rehashing skipped ('openssl' program not available)\n";
                exit 0;
        }
 }
 
-if(@ARGV) {
+if (@ARGV) {
        @dirlist = @ARGV;
-} elsif($ENV{SSL_CERT_DIR}) {
+} elsif ($ENV{SSL_CERT_DIR}) {
        @dirlist = split /$path_delim/, $ENV{SSL_CERT_DIR};
 } else {
        $dirlist[0] = "$dir/certs";
@@ -84,36 +93,42 @@ if (-d $dirlist[0]) {
 }
 
 foreach (@dirlist) {
-       if(-d $_ and -w $_) {
+       if (-d $_ ) {
+            if ( -w $_) {
                hash_dir($_);
+            } else {
+                print "Skipping $_, can't write\n";
+                $errorcount++;
+            }
        }
 }
+exit($errorcount);
 
 sub hash_dir {
        my %hashlist;
        print "Doing $_[0]\n";
        chdir $_[0];
        opendir(DIR, ".");
-       my @flist = readdir(DIR);
+       my @flist = sort readdir(DIR);
        closedir DIR;
        if ( $removelinks ) {
                # Delete any existing symbolic links
                foreach (grep {/^[\da-f]+\.r{0,1}\d+$/} @flist) {
-                       if(-l $_) {
-                               unlink $_;
+                       if (-l $_) {
                                print "unlink $_" if $verbose;
+                               unlink $_ || warn "Can't unlink $_, $!\n";
                        }
                }
        }
        FILE: foreach $fname (grep {/\.(pem)|(crt)|(cer)|(crl)$/} @flist) {
                # Check to see if certificates and/or CRLs present.
                my ($cert, $crl) = check_file($fname);
-               if(!$cert && !$crl) {
+               if (!$cert && !$crl) {
                        print STDERR "WARNING: $fname does not contain a certificate or CRL: skipping\n";
                        next;
                }
-               link_hash_cert($fname) if($cert);
-               link_hash_crl($fname) if($crl);
+               link_hash_cert($fname) if ($cert);
+               link_hash_crl($fname) if ($crl);
        }
 }
 
@@ -122,14 +137,14 @@ sub check_file {
        my $fname = $_[0];
        open IN, $fname;
        while(<IN>) {
-               if(/^-----BEGIN (.*)-----/) {
+               if (/^-----BEGIN (.*)-----/) {
                        my $hdr = $1;
-                       if($hdr =~ /^(X509 |TRUSTED |)CERTIFICATE$/) {
+                       if ($hdr =~ /^(X509 |TRUSTED |)CERTIFICATE$/) {
                                $is_cert = 1;
-                               last if($is_crl);
-                       } elsif($hdr eq "X509 CRL") {
+                               last if ($is_crl);
+                       } elsif ($hdr eq "X509 CRL") {
                                $is_crl = 1;
-                               last if($is_cert);
+                               last if ($is_cert);
                        }
                }
        }
@@ -156,7 +171,7 @@ sub link_hash_cert {
                # Search for an unused hash filename
                while(exists $hashlist{"$hash.$suffix"}) {
                        # Hash matches: if fingerprint matches its a duplicate cert
-                       if($hashlist{"$hash.$suffix"} eq $fprint) {
+                       if ($hashlist{"$hash.$suffix"} eq $fprint) {
                                print STDERR "WARNING: Skipping duplicate certificate $fname\n";
                                return;
                        }
@@ -164,15 +179,21 @@ sub link_hash_cert {
                }
                $hash .= ".$suffix";
                if ($symlink_exists) {
-                       symlink $fname, $hash;
                        print "link $fname -> $hash\n" if $verbose;
+                       symlink $fname, $hash || warn "Can't symlink, $!";
                } else {
-                       open IN,"<$fname" or die "can't open $fname for read";
-                       open OUT,">$hash" or die "can't open $hash for write";
-                       print OUT <IN>; # does the job for small text files
-                       close OUT;
-                       close IN;
                        print "copy $fname -> $hash\n" if $verbose;
+                        if (open($in, "<", $fname)) {
+                            if (open($out,">", $hash)) {
+                                print $out $_ while (<$in>);
+                                close $out;
+                            } else {
+                                warn "can't open $hash for write, $!";
+                            }
+                            close $in;
+                        } else {
+                            warn "can't open $fname for read, $!";
+                        }
                }
                $hashlist{$hash} = $fprint;
 }
@@ -191,7 +212,7 @@ sub link_hash_crl {
                # Search for an unused hash filename
                while(exists $hashlist{"$hash.r$suffix"}) {
                        # Hash matches: if fingerprint matches its a duplicate cert
-                       if($hashlist{"$hash.r$suffix"} eq $fprint) {
+                       if ($hashlist{"$hash.r$suffix"} eq $fprint) {
                                print STDERR "WARNING: Skipping duplicate CRL $fname\n";
                                return;
                        }
@@ -199,12 +220,12 @@ sub link_hash_crl {
                }
                $hash .= ".r$suffix";
                if ($symlink_exists) {
-                       symlink $fname, $hash;
                        print "link $fname -> $hash\n" if $verbose;
+                       symlink $fname, $hash || warn "Can't symlink, $!";
                } else {
-                       system ("cp", $fname, $hash);
                        print "cp $fname -> $hash\n" if $verbose;
+                       system ("cp", $fname, $hash);
+                        warn "Can't copy, $!" if ($? >> 8) != 0;
                }
                $hashlist{$hash} = $fprint;
 }
-